/*
---
description: A simple Mootools class to beauty your form similar to the Apple Store checkout form.

license: MIT-style

authors:
- Ejaz

requires:
- Mootools Core 1.2.4


...
*/
var PlaceHolder = new Class(
{
	Implements : [Options],
	options : {
		focusClass : "",
		blurClass : "",
		positionClass : ""
	},
	initialize : function(formId, options)
	{
		this.form = $(formId);
		this.setOptions(options);
		this.buildHolders();
	},
	buildHolders : function()
	{
		var self = this;
		var alInputs = this.form.getElements("input[type='text']");
		alInputs.combine(this.form.getElements("input[type='password']"));
		alInputs.each(function(elm, elmCounter)
		{
			
			// make wrapper
			var spWrapper = new Element("span", {"id" : "wp-"+elm.get("name"), "class" : "spanWrappers"}).setStyles({
				display : 'inline-block',
				position : 'relative'
			}).injectInside(elm.getParent()).adopt(elm);
			
			// add labels
			var spLabel = new Element("span", {"html" : elm.get("title"), "id" : "pc-"+elm.get("name"), "class" : self.options.positionClass+" "+self.options.blurClass}).setStyles({
				position : 'absolute',
				'z-index' : 2
			}).inject(elm, "before");

                        spLabel.addEvent('click', function()
                        {
                            this.getNext().focus();
                        });
			
			// fade out the label if value already exists
			if($chk(elm.get("value"))){
				spLabel.fade("out");
			}
			
			elm.addEvents({
				'focus' : function() // add focus event
				{
					var spn = $("pc-"+elm.get("name"));
					
					if($chk(elm.get("value")))
					{
						spn.fade("out");
						spn.removeClass(self.options.focusClass);
					}
					else
					{
						spn.fade("in");
						spn.addClass(self.options.focusClass);
						spn.removeClass(self.options.blurClass);
					}
				},
				'keyup' :  function() // add key up event
				{
					var spn = $("pc-"+elm.get("name"));
					if($chk(elm.get("value")))
					{
						spn.fade("out");
					}
					else
					{
						spn.fade("in");
						spn.addClass(self.options.focusClass);
					}
				},
				'blur' : function() // add blur event
				{
					var spn = $("pc-"+elm.get("name"));
					spn.removeClass(self.options.focusClass);
					spn.addClass(self.options.blurClass);
				}
			});
		});
	}
});
